﻿@using System.Globalization
@model List<SP_GetGridReceipt_Result>
@{
    string search = ViewBag.Search,
        orderColumn = ViewBag.OrderColumn,
        orderDirection = ViewBag.OrderDirection,
        memberId = ViewBag.MemberId,
        tglAwal = ViewBag.TglAwal,
        tglAkhir = ViewBag.TglAkhir,
        channel = ViewBag.Channel,
        spgCode = ViewBag.SPGCode,
        retailAddr = ViewBag.RetailerAddr;
    int? eventCode = ViewBag.EventCode,
         retailHidden = ViewBag.Retailer;

    int currentPage = ViewBag.CurrentPage,
        totalPage = ViewBag.TotalPage,
        paginationShowRange = 5,
        totalRow = ViewBag.TotalRow;
    int? status = ViewBag.Status;

    bool isSPG = ViewBag.IsSpg != null ? (bool)ViewBag.IsSpg : false;

    string GetOtherChainValuesApp = System.Web.Configuration.WebConfigurationManager.AppSettings["OtherChainValues"];
}

@if (ViewBag.ErrorValidation != null)
{
    <div class="alert alert-danger">
        <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
        <i class="fa fa-times-circle"></i>
        Error occured: <br />
        @ViewBag.ErrorValidation
    </div>
}

<div class="widget-header">
    <h4><i class="icon-reorder"></i>All Receipt</h4>
</div>
<div class="right-title">
    <form name="gridForm">
        <input type="text" id="txtSearch" name="txtSearch" value="@search" class="form-control box-search" placeholder="Search for...">
        <input type="hidden" id="rawDataUrl" name="rawDataUrl" value="@GenerateUrl("@search@", "", "", "", null, "",  "", 0,orderColumn, orderColumn, orderDirection, 0, retailHidden, retailAddr)" />
    </form>
</div>
<div id="grid-wrapper" class="widget-content">
    <table class="table table-striped grid-table">
        <thead>
            <tr>
                @*<th class="grid-header" title="Type"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "Type", orderColumn, orderDirection, 0)">Type</a></div></th>*@
                <th class="grid-header" title="MemberName">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "MemberName", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Name</a>
                    </div>
                </th>
                <th class="grid-header" title="MemberPhone">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "MemberPhone", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Phone</a>
                    </div>
                </th>
                <th class="grid-header" title="MemberEmail">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "MemberEmail", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Email</a>
                    </div>
                </th>
                <th class="grid-header" title="Code">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "Code", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Code</a>
                    </div>
                </th>
                <th class="grid-header" title="ReceiptCode">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "ReceiptCode", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Receipt Code</a>
                    </div>
                </th>
                <th class="grid-header" title="ReceiptTransactionDate">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "ReceiptTransactionDate", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Transaction Date</a>
                    </div>
                </th>
                <th class="grid-header" title="RetailerName">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "RetailerName", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Retailer</a>
                    </div>
                </th>
                <th class="grid-header" title="ReceiptStatus">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "ReceiptStatus", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Status</a>
                    </div>
                </th>
                <th class="grid-header" title="Reject">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "Reject", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Reject Reason</a>
                    </div>
                </th>
                <th class="grid-header" title="ReceiptChannel">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "ReceiptChannel", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Channel</a>
                    </div>
                </th>
                <th class="grid-header" title="ReceiptSPGCode">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "ReceiptSPGCode", orderColumn, orderDirection, 0, retailHidden, retailAddr)">SPG Code</a>
                    </div>
                </th>
                <th class="grid-header" title="CollectRemarks">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "CollectRemarks", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Remarks</a>
                    </div>
                </th>
                <th class="grid-header" title="CreatedDate">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "CreatedDate", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Created Date</a>
                    </div>
                </th>
                <th class="grid-header" title="CreatedDate">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "UpdatedDate", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Updated Date</a>
                    </div>
                </th>
                <th class="grid-header" title="EventCode">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "EventCode", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Event Code</a>
                    </div>
                </th>
                <th class="grid-header" title="EventCode">
                    <div class="grid-header-title">
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel, spgCode, eventCode, "ReceiptType", orderColumn, orderDirection, 0, retailHidden, retailAddr)">Receipt Type</a>
                    </div>
                </th>
                <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
                <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
            </tr>
        </thead>
        <tbody>
            @foreach (SP_GetGridReceipt_Result receipt in Model)
            {
            <tr class="grid-row ">
                @*<td class="grid-cell" data-name="Type">@member.Type</td>*@
                <td class="grid-cell" data-name="MemberName">@receipt.MemberName</td>
                <td class="grid-cell" data-name="MemberPhone">@receipt.MemberPhone</td>
                <td class="grid-cell" data-name="MemberEmail">@receipt.MemberEmail</td>
                <td class="grid-cell" data-name="Code">@receipt.Code</td>
                <td class="grid-cell" data-name="ReceiptCode">@receipt.ReceiptCode</td>
                <td class="grid-cell" data-name="ReceiptTransactionDate">@RenderTransactionDate(receipt.ReceiptTransactionDate)</td>
                <td class="grid-cell" data-name="RetailerName">@receipt.RetailerName</td>
                <td class="grid-cell" data-name="ReceiptStatus">@RenderStatus(receipt.ReceiptStatus)</td>
                <td class="grid-cell" data-name="Reject">@receipt.Reject</td>
                <td class="grid-cell" data-name="ReceiptChannel">@receipt.ReceiptChannel</td>
                <td class="grid-cell" data-name="ReceiptChannel">@receipt.SPGCode</td>
                <td class="grid-cell" data-name="CollectRemarks">@RenderRemarks(receipt.CollectRemarks)</td>
                <td class="grid-cell" data-name="CreatedDate">@(receipt.CreatedDate.ToString("dd-MM-yyyy"))</td>
                <td class="grid-cell" data-name="UpdatedDate">@(receipt.UpdatedDate.HasValue ? receipt.UpdatedDate.Value.ToString("dd-MM-yyyy") : "")</td>
                <td class="grid-cell" data-name="EventCode">@receipt.EventCode</td>
                <td class="grid-cell" data-name="EventCode">@((receipt.IsOnline ?? false) ? "Online" : "Offline")  </td>
                @if (!isSPG)
                {
                    bool canModerate = false
                        , canEdit = false;

                    var hist = HistoryEditChain.GetByReceiptId(receipt.ReceiptId);

                    canModerate = receipt.ReceiptStatus != (int)Receipt.ReceiptStatus.Approve
                        && receipt.ReceiptStatus != (int)Receipt.ReceiptStatus.WaitingUnverify
                        && receipt.ReceiptStatus != (int)Receipt.ReceiptStatus.OcrApproved
                        && receipt.ReceiptStatus != (int)Receipt.ReceiptStatus.OcrProcessing;

                    receipt.ChainValues = receipt.ChainValues ?? string.Empty;

                    canEdit = receipt.ReceiptStatus == (int)Receipt.ReceiptStatus.OcrApproved
                        && GetOtherChainValuesApp.Contains(receipt.ChainValues)
                        && !string.IsNullOrEmpty(receipt.ChainValues)
                        && hist == null;

                    <td class="grid-cell cell-center" data-name="">
                        @if (canModerate)
                        {
                            <a href="@Url.Action(MVC.Receipt.Moderate(receipt.ReceiptId))" target="_blank" class="btn btn-xs btn-danger">Moderate </a>
                        }
                        else
                        {
                            <a href="@Url.Action(MVC.Receipt.Detail(receipt.ReceiptId))" target="_blank" class="btn btn-xs btn-success">Detail </a>
                        }

                        @if (canEdit)
                        {
                            <a href="@Url.Action(MVC.Receipt.Edit(receipt.ReceiptId))" target="_blank" class="btn btn-xs btn-success">Edit </a>
                        }
                    </td>
                    if (receipt.IsOnline ?? false)
                    {
                        <td></td>
                    }
                    else
                    {
                        <td class="grid-cell cell-center" data-name=""><a href="@Url.Action(MVC.Receipt.DownloadJson(receipt.ReceiptId))" class="btn btn-xs btn-warning">Download Json</a></td>
                    }
                    <td></td>
                }
            </tr>
            }
        </tbody>
    </table>
    @if (totalPage > 1)
    {
        int startPage = currentPage - paginationShowRange > 1 ? currentPage - paginationShowRange : 1,
            endPage = currentPage + paginationShowRange < totalPage ? currentPage + paginationShowRange : totalPage;

        <div class="grid-footer">

            <div class="grid-pager">
                <ul class="pagination">
                    <li>
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel,spgCode, eventCode, orderColumn, orderColumn, orderDirection, currentPage <= 1 ? currentPage : currentPage - 1, retailHidden, retailAddr, true)" class="grid-prev-page" title="Previous Page" style="">
                            <span class="glyphicon glyphicon-step-backward"></span>
                        </a>
                    </li>
                    @for (var _page = startPage; _page <= endPage; _page++)
                    {
                        @*<li><a href="#" class="grid-pageSetLink prev" style="display: none;" data-pageset="1" data-partitionsize="5">...</a></li>*@
                        <li class="@(currentPage == _page ? "active": "")">
                            <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel,spgCode, eventCode, orderColumn, orderColumn, orderDirection, _page, retailHidden, retailAddr, true)" class="grid-page-link">
                                @_page
                            </a>
                        </li>
                    }
                    @if (totalPage >= 7)
                    {
                        <li>
                            <a class="grid-page-link">
                                Total Page @totalPage
                            </a>
                        </li>
                    }
                    <li>
                        <a data-url="@GenerateUrl(search, memberId, tglAwal, tglAkhir, status, channel,spgCode, eventCode, orderColumn, orderColumn, orderDirection, currentPage >= endPage ? endPage : currentPage + 1, retailHidden, retailAddr, true)" title="Next Page" class="grid-next-page">
                            <span class="glyphicon glyphicon-step-forward"></span>
                        </a>
                    </li>
                </ul>
            </div>
            <div>
                Total Row : @totalRow
            </div>
        </div>
    }
</div>

@helper RenderStatus(int StatusID)
{
    string status = Enum.GetName(typeof(Receipt.ReceiptStatus), StatusID);
    string statusclass = string.Empty;
    if (status == Receipt.ReceiptStatus.Reject.ToString() || status == Receipt.ReceiptStatus.OcrReject.ToString())
    {
        statusclass = "alert-danger";
    }
    else if (status == Receipt.ReceiptStatus.Waiting.ToString() || status == Receipt.ReceiptStatus.WaitingUnverify.ToString() || status == Receipt.ReceiptStatus.WaitingVerify.ToString())
    {
        statusclass = "alert-warning";
    }
    else
    {
        statusclass = "alert-success";
    }
    <span class="@statusclass">
        @status
    </span>
}

@helper RenderRemarks(string remarks)
{
    string statusclass = string.Empty;
    statusclass = "alert-warning";

    <span class="@statusclass">
        @remarks
    </span>
}

@helper RenderTransactionDate(DateTime? transactionDate)
{
    if (transactionDate.HasValue)
    {
        @:@transactionDate.Value.ToString("dd-MM-yyyy HH:mm:ss", CultureInfo.InvariantCulture)
    }
    else
    {
        @:NULL
    }
}

@functions {
    public string GetOrderDirectionByColumn(string currentCol, string currentDirection, string targetColumn, bool isPaging)
    {
        if (isPaging) return currentDirection;

        if (currentCol.ToLower() == targetColumn.ToLower())
        {
            if (currentDirection.ToLower() == "asc") return "Desc";
            else return "Asc";
        }
        return currentDirection;
    }

    public string GenerateUrl(string search, string memberIDHidden, string hiddenAwal, string hiddenAkhir, int? hiddenStatus, string hiddenChannel, string spgCodeHidden, int? eventCodeHidden, string targetColumn, string orderColumn, string orderDirection, int? page, int? retailerHidden, string retailerHasAddr, bool isPaging = false)
    {
        return Url.Action(MVC.Receipt.GridGetAllReceiptPager(search, page, memberIDHidden, hiddenAwal, hiddenAkhir, hiddenStatus, hiddenChannel, spgCodeHidden, eventCodeHidden, retailerHidden, retailerHasAddr, targetColumn, GetOrderDirectionByColumn(orderColumn, orderDirection, targetColumn, isPaging)));
    }
}